/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;

import javax.validation.Valid;

import org.springblade.common.constant.EstateConstant;
import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.community.vo.ResidentialVO;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.entity.Car;
import org.springblade.estate.service.ICarService;
import org.springblade.estate.vo.ParkingSpaceStatVO;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.estate.entity.ParkingSpace;
import org.springblade.estate.vo.ParkingSpaceVO;
import org.springblade.estate.wrapper.ParkingSpaceWrapper;
import org.springblade.estate.service.IParkingSpaceService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.Map;
import java.util.Objects;

/**
 * 车位信息 控制器
 *
 * @author BladeX
 * @since 2021-03-30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/parkingspace")
@Api(value = "车位信息", tags = "车位信息接口")
public class ParkingSpaceController extends BladeController {

	private final IParkingSpaceService parkingSpaceService;
	private final IOrgPositionClient orgPositionClient;
	private final IResidentialClient residentialClient;
	private final ICarService carService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入parkingSpace")
	public R<ParkingSpaceVO> detail(ParkingSpace parkingSpace) {
		ParkingSpace detail = parkingSpaceService.getOne(Condition.getQueryWrapper(parkingSpace));
		return R.data(ParkingSpaceWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 车位信息
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入parkingSpace")
	public R<IPage<ParkingSpaceVO>> list(@RequestParam Map<String, Object> parkingSpace, Query query, BladeUser bladeUser) {
		LambdaQueryWrapper<ParkingSpace> parkingSpaceLambdaQueryWrapper = new QueryWrapperUtil<ParkingSpace>().getBasicQueryWrapperByMap(ParkingSpace::getOrgPosition, parkingSpace, new ParkingSpace(), bladeUser, orgPositionClient);
		IPage<ParkingSpace> pages = parkingSpaceService.page(Condition.getPage(query), parkingSpaceLambdaQueryWrapper);
		return R.data(ParkingSpaceWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 车位信息
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入parkingSpace")
	public R<IPage<ParkingSpaceVO>> page(ParkingSpaceVO parkingSpace, Query query) {
		IPage<ParkingSpaceVO> pages = parkingSpaceService.selectParkingSpacePage(Condition.getPage(query), parkingSpace);
		return R.data(pages);
	}

	/**
	 * 新增 车位信息
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入parkingSpace")
	public R save(@Valid @RequestBody ParkingSpace parkingSpace) {
		return R.status(parkingSpaceService.save(parkingSpace));
	}

	/**
	 * 修改 车位信息
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入parkingSpace")
	public R update(@Valid @RequestBody ParkingSpace parkingSpace) {
		return R.status(parkingSpaceService.updateById(parkingSpace));
	}

	/**
	 * 新增或修改 车位信息
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入parkingSpace")
	public R submit(@Valid @RequestBody ParkingSpace parkingSpace) {
		Residential residential = new Residential();
		residential.setId(parkingSpace.getResidentialId());
		ResidentialVO residentialVO = residentialClient.detail(residential);
		parkingSpace.setOrgPosition(residentialVO.getOrgPosition());
		return R.status(parkingSpaceService.saveOrUpdate(parkingSpace));
	}

	/**
	 * 新增或修改 车位信息
	 */
	@PostMapping("/saveOrUpdate")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入parkingSpace")
	public R saveOrUpdate(@Valid @RequestBody ParkingSpace parkingSpace) {
		return R.status(parkingSpaceService.saveOrUpdate(parkingSpace));
	}


	/**
	 * 删除 车位信息
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(parkingSpaceService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 详情
	 */
	@GetMapping("/statistics")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入parkingSpace")
	public R statistics() {
		//总泊车位
		int totalCount = parkingSpaceService.count();
		//已泊车位【已占用的车位】
		int isUseCount = parkingSpaceService.count(Condition.getQueryWrapper(new ParkingSpace()).lambda()
			.eq(ParkingSpace::getIsUsed, EstateConstant.ParkingSpaceConstant.IS_USED.getValue()));
		//已泊车位【剩余的车位】
		int notUseCount = totalCount - isUseCount;

		return R.data(ParkingSpaceStatVO.builder()
			.totalCount(totalCount)
			.isUseCount(isUseCount)
			.notUseCount(notUseCount)
			.build());
	}

	/**
	 * 删除 车位信息
	 * 解绑车辆信息后再删除
	 */
	@PostMapping("/removeParkingSpace")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R removeParkingSpace(@ApiParam(value = "主键集合", required = true) @RequestParam String id) {
		ParkingSpace parkingSpace = parkingSpaceService.getById(id);
		Assert.notNull(parkingSpace, "找不到车位信息");
		Long carId = parkingSpace.getCarId();
		//解绑车辆
		if (!Objects.isNull(carId)) {
			Car car = carService.getById(carId);
			if (car != null) {
				car.setParkingLotId(null);
				carService.updateById(car);
			}
		}
		return R.status(parkingSpaceService.removeById(id));
	}


	/**
	 * 绑定车辆
	 */
	@PostMapping("/bindCar")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "绑定车辆", notes = "传入ids")
	public R bindCar(@RequestParam Long carId, @RequestParam Long parkingSpaceId) {
		return R.status(parkingSpaceService.bindCar(carId, parkingSpaceId));
	}


}
